#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/*
date: 2002.05.28
mat@monkey.org
*/	
void dump_hex(char *buffer,int len)
{
	int i,j;

	printf("==============================\n");
	for(i=0;i<len;i+=16)
	{
		for(j=i;j<i+16;j++)
		{
			printf("%.2x ",buffer[i+j]&0xff);
			if(j%4==3)
			{
				printf("|");
			}
		}
		for(j=i;j<i+16;j++)
		{
			if(isprint(buffer[i+j]))
			{
				printf("%c",buffer[i+j]&0xff);
			}else{
				printf(".");
			}
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);
}

void decrypt_data(char *input_buffer,int input_buffer_len)
{
	char output_buffer[1024]={0,};
	char local_buffer[1024]={0,};
	int input_buffer_i=input_buffer_len-1;
	int tmp_var;
	int res_var;
	int i;
	int edx;
	int op_code;
	int address_mode;

	while(input_buffer_i>=0)
	{
		if(input_buffer_i==0)
		{
			//TODO: 0x804a22c
			tmp_var=input_buffer[0];
		}else{
			tmp_var=input_buffer[input_buffer_i]-input_buffer[input_buffer_i-1];
		}
		res_var=tmp_var-23;
		if(res_var<0)
		{
			//TODO: 0x804a239
			while(res_var<0)
			{
				res_var+=0x100;
			}
		}
		memcpy(local_buffer,output_buffer,input_buffer_len);
		output_buffer[0]=res_var;
		if(input_buffer_len>1)
		{
			for(i=1;i<input_buffer_len;i++)
			{
				output_buffer[i]=local_buffer[i-1];
			}
		}
		sprintf(output_buffer,"%c%s",res_var,local_buffer);
		input_buffer_i--;
	}
	
#define BASE 2
	op_code=output_buffer[BASE+1]-1;
	printf("op_code: %d\n",op_code);
	switch(op_code)
	{
		case 1:
			address_mode=output_buffer[BASE+0x2];
			printf("address_mode: %d\n",address_mode);
			if(address_mode==2)
			{
				for(i=0;i<9;i++)
				{
					printf("%d.%d.%d.%d\n",output_buffer[BASE+0x3+4*i],output_buffer[BASE+0x4+4*i],output_buffer[BASE+0x5+4*i],output_buffer[BASE+0x6+4*i]);
				}
			}
			if(address_mode==1)
			{
				printf("address: %u.%u.%u.%u\n",output_buffer[BASE+0x3]&0xff,output_buffer[BASE+0x4]&0xff,output_buffer[BASE+0x5]&0xff,output_buffer[BASE+0x6]&0xff);
			}
	}
	dump_hex(output_buffer,input_buffer_len);
}

void main(int argc,char *argv[])
{
	char *input_filename;
	int input_fd;
	char onechar;
	char buffer[1024];
	int rc;
	if(argc<2)
	{
		fprintf(stderr,"usage: %s <file name>\n",argv[0]);
		fflush(stderr);
		return;
	}
	input_filename=argv[1];

	input_fd=open(input_filename,O_RDONLY);
	if(input_fd<0)
	{
		fprintf(stderr,"open failed: %s\n",input_filename);
		fflush(stderr);
		exit(0);
	}
	while((rc=read(input_fd,(void *)buffer,sizeof(buffer)))>0)
	{
		printf("rc is %d\n",rc);
		decrypt_data(buffer,rc);
	}
	close(input_fd);
}
