#!/usr/bin/perl
require("/etc/re_config.pl");
push(@INC,$modules_dir);
require("sublist.pl");
require("format_calls_lib.pl");

use Getopt::Std; 
getopt('d:');

my $replace=0;
my $global_sub_file="sub.list";

my $data_file="the-binary.data";
$data_file=$opt_d;

open(DATA_FILE,"<$data_file") || die "unable to open data-file: $data_file\n";
while (<DATA_FILE>) {
	if(/^0x.*:/ && !/<Address 0x.* out of bounds>/)
	{
		@elements=split(/:[ \t]+/);
		$elements[0]=~s/\n//g;
		$elements[1]=~s/\n//g;
		$elements[1]=~s/^\"//;
		$elements[1]=~s/\"$//;
		if($debug_sub)
		{
			print "$elements[0]=$elements[1]\n";
		}
		$data_table{$elements[0]}="$elements[1]";
	}
}
close(DATA_FILE);

foreach my $input_file (@ARGV)
{
	print STDERR "Processing $input_file\n";
	my $calladdr=$input_file;
	$calladdr=~s/\.call$//;
	my $output_file="";
	my $debug=0;
	my $debug_sub=0;
	my $enable_html=1;
	$history_hash;
	$history_array_n=0;
	$history_array;
	$stack_array_n=0;
	$stack_array;
	$sub_list_n=0;
	my $last_call_addr=0;
	my $whole_buffered_str="";
	my $buffered_str;
	my $buffered_str_n=0;
	
	
	open(UNISTD,"<$unistd_file") || die "unable to open $unistd_file\n";
	while (<UNISTD>) {
		if (/^#define/)
		{
			@elements=split(/[ \t]+/);
			$elements[2]=~s/\n//g;
			if ($elements[1] =~ /^__NR/ && $elements[2]=~ /[0-9]+/)
			{
				if($debug_sub)
				{
					print "$elements[1]=$elements[2]\n";
				}
				$system_call_table{$elements[2]}=$elements[1];
			}
		}
	}
	close(UNISTD);
	
	$output_file=$input_file;
	$output_file=~s/\.call//;
	my $output_file_ext=".html";
	$output_file=~s/$/$output_file_ext/;
	open(OUTPUT_FILE,">$output_file") || die "unable to open $output_file\n";
	
	
	print OUTPUT_FILE $html_header;
	
	$info_page_links_str=sprintf($info_page_links_format,$process_sub_list_action_location,$calladdr,$html_doc_root,$calladdr,$html_doc_root,$calladdr);
	print OUTPUT_FILE $info_page_links_str;
	
	$jmp_level=0;
	$jmp_array_n=0;
	
	local $old_indent_num=0;
	open(INPUT_FILE,"<$input_file") || die "unable to open $input_file\n";
	while (<INPUT_FILE>) {
		if($debug)
		{
			print OUTPUT_FILE $_;
		}
		my $addr=get_addr($_);
		my $op=get_op($_);
		my $src=get_src($_);
		my $dst=get_dst($_);
		my $delim="";
		if($debug)
		{
			print OUTPUT_FILE "$addr: $op/$src/$dst\n";
		}
		if(is_saving_op($op))
		{
			#print OUTPUT_FILE $_;
			$history_hash{$dst}{$addr}="$src";
			$history_array[$history_array_n][0]=$addr;
			if($op=~/sub/)
			{
				$history_array[$history_array_n][1]="-=";
			}elsif($op=~/lea/)
			{
				$history_array[$history_array_n][1]="=&";
			}elsif($op=~/add/)
			{
				$history_array[$history_array_n][1]="+=";
			}else{
				$history_array[$history_array_n][1]="=";
			}
			$history_array[$history_array_n][2]=$src;
			$history_array[$history_array_n][3]=$dst;
			$history_array_n++;
		}
		if(is_call_op($op))
		{
			$history_hash{"%eax"}{$addr}="=$src $addr";
			$history_array[$history_array_n][0]=$addr;
			$history_array[$history_array_n][1]="=call ";
			$history_array[$history_array_n][2]="($src $addr)";
			$history_array[$history_array_n][3]="%eax";
			$history_array_n++;
		}
		if(is_push_op($op))
		{
			$stack_array[$stack_array_n][0]=$addr;
			$stack_array[$stack_array_n][1]=$src;
			$stack_array_n++;
			if($stack_array_n>4)
			{
				$is_call_prepare=1;
			}
		}
		if(is_jmp_op($op))
		{
			$jmp_array[$jmp_array_n][0]=$addr;
			$jmp_array[$jmp_array_n][1]=$src;
			$jmp_array_n++;
		}
	
		if($enable_html)
		{
			local $indent_num=get_indent_num($addr);
			if($dst=~/^$/)
			{
				$delim="";
			}else{
				$delim=",";
			}
			$hex_addr=hex($addr);
			$addr_str=sprintf("0x%x",$hex_addr+1);
			local $src_str=make_target_html($addr_str,$op,$src,1,1,$calladdr);
			local $dst_str=make_target_html($addr_str,$op,$dst,1,1,$calladdr);
			if(!is_call_op($op))
			{
				$addr_html=make_addr_html($addr,$calladdr);
				my $outstr="$addr_html: $op $src_str $delim $dst_str";
				if($op=~/int/)
				{
					$eax_str=get_element_history_string($addr,"%eax");
					$eax_str=~ s/^=\$//;
					$eax_str=$system_call_table{hex($eax_str)};
					$outstr="$addr: $op $src_str $eax_str";
				}
	
				$outstr=substitute_list($addr,$outstr,0);
				if($is_call_prepare)
				{
					$buffered_str[$buffered_str_n]=substitute_list($addr,$outstr,1);
					$whole_buffered_str="$whole_buffered_str$buffered_str[$buffered_str_n]\n";
					$buffered_str_n++;
					printf OUTPUT_FILE sprintf($name_line,$addr);
				}else{
					$color="#ffffff";
					if($op=~/add/ && $dst=~/%esp/)
					{
						$color="#ffffff";
					}elsif($op=~/test/ || $op=~/cmp/)
					{
						$color="#00ffff";
					}elsif($op=~/^j/)
					{
						$color="#ffff00";
					}
					if($old_indent_num!=$indent_num)
					{
						print OUTPUT_FILE $delimit_str;
					}
					printf OUTPUT_FILE sprintf($tr_start_form,$indent_num*10);
					print OUTPUT_FILE sprintf($td_line_2,$outstr);
					if($op=~/int/)
					{
						$ebx_str=get_element_history_string($addr,"%ebx");
						$ecx_str=get_element_history_string($addr,"%ecx");
						$edx_str=get_element_history_string($addr,"%edx");
						$esi_str=get_element_history_string($addr,"%esi");
						$edi_str=get_element_history_string($addr,"%edi");
						print OUTPUT_FILE sprintf($pre_line,"ebx$ebx_str\necx$ecx_str\nedx$edx_str\nesi$esi_str\nedi$edi_str");
					}
					local $tr_end_str=sprintf($tr_end,"","POS:$addr");
					print OUTPUT_FILE $tr_end_str;
				}
			}else {
				#call output file
				#TODO: invalid callstacks!
				$call_output_file="$addr$output_file_ext";
				open(CALL_OUTPUT_FILE,">$call_output_file") || die "unable to open $call_output_file\n";
				print CALL_OUTPUT_FILE $html_header;
				print CALL_OUTPUT_FILE sprintf($pre_line,$whole_buffered_str);
				print CALL_OUTPUT_FILE $close_html;
				print CALL_OUTPUT_FILE $html_tailer;
				close CALL_OUTPUT_FILE;


				$addr_html=make_addr_html($addr,$calladdr);
				$show_call_link=make_show_call_link($addr,$calladdr);
				$outstr=sprintf($show_call_line,$addr_html,$show_call_link,$op,$src_str);
				$outstr=substitute_list($addr,$outstr,0);
				printf OUTPUT_FILE sprintf($tr_start_form,$indent_num*10);
				print OUTPUT_FILE sprintf($td_line,$outstr);
				$whole_buffered_str="";
				local $stack_str=get_stack($last_call_addr,$addr,$calladdr);
				$stack_str=substitute_list($addr,$stack_str,0);
				print OUTPUT_FILE $stack_str;
				local $tr_end_str=sprintf($tr_end,"CALLPROTO:$src","POS:$addr");
				print OUTPUT_FILE $tr_end_str;
				$is_call_prepare=0;
			}
			$old_indent_num=$indent_num;
		}
		if(is_call_op($op))
		{
			$last_call_addr=$addr;
		}
	}
	close(INPUT_FILE);
	
	print OUTPUT_FILE $html_tailer;
	close(OUTPUT_FILE);
}
