#!/usr/bin/perl
require("/etc/re_config.pl");
push(@INC,$modules_dir);
local $inputfile=$ARGV[0];
local $command="objdump -dj .text $inputfile";
open(OBJDUMP,"$command|") || die "failed to execute $command\n";
my $calls_n=0;

sub find_in_calls
{
	local ($addr)=@_;
	for($calls_i=0;$calls_i<$calls_n;$calls_i++)
	{
		if($calls[$calls_i][1] eq $addr)
		{
			return 1;
		}
	}
	return 0;
}

while (<OBJDUMP>)
{
	chomp($_);
	#$_=~/:       [0-9a-f]+;
	@elements=split(/[ \t][ \t]+/);
	$elements[0]=~s/^[ \t]+//;
	$elements[0]=~s/[ \t]+.*$//;
	if($elements[0]=~/^[0-9a-f]+:/)
	{
		$addr="0x$elements[0]";
		$addr=~s/:$//;
		$op=$elements[1];
		$operands=$elements[2];
		if($op=~/^call/)
		{
			$calls[$calls_n][0]=$addr;
			$calls[$calls_n][1]=$operands;
			$calls_n++;
		}
	}
}
close (OBJDUMP);

#second phase
open(OBJDUMP,"$command|") || die "failed to execute $command\n";
my $in_call=0;
while (<OBJDUMP>)
{
	chomp($_);
	#$_=~/:       [0-9a-f]+;
	@elements=split(/[ \t][ \t]+/);
	$elements[0]=~s/^[ \t]+//;
	$elements[0]=~s/[ \t]+.*$//;
	if($elements[0]=~/^[0-9a-f]+:/)
	{
		$addr="0x$elements[0]";
		$addr=~s/:$//;
		$op=$elements[1];
		$operands=$elements[2];
		if($in_call==0 || find_in_calls($addr))
		{
			close (CALLFILE);
			my $callfile="$addr.call";
			open(CALLFILE,">$callfile") || die "failed to execute $callfile\n";
			print STDERR "writing $callfile\n";
			$in_call=1;
		}
		if($in_call)
		{
			print CALLFILE "$addr:\t$op\t$operands\n";
		}
	}
}
close (OBJDUMP);
